var GLOBAL_SERIAL_NO = localStorage.getItem('client_id');
var intervalId = null;
$(document).ready(function () {
    var events = [];
    var methods = {
        one_click_service: function (parsedJSON) {
            if (typeof oneClickServiceHandler !== 'undefined' && $.isEmptyObject(oneClickServiceHandler) === false) {
                oneClickServiceHandler.setRequestIds(parsedJSON);
            }
            $.each(Object.keys(window), function(i, memberName){
                if(memberName.substr(0, "buttonHandler".length) === "buttonHandler") {
                    window[memberName].setRequestIds(parsedJSON);
                }
            });
        },
        ad_banner: function (parsedJSON) {
            if (typeof adbannerHandler !== 'undefined' && $.isEmptyObject(parsedJSON) === false) {
                if(parsedJSON.isDelete) {
                    parsedJSON.deleteMap.split(',').map(function(adbannerId) {
                        removeHandler(adbannerId);
                    });
                } else {
                    $.each(parsedJSON, function(i, adbanner){
                        if (adbannerHandler.isNewEvent(Number(adbanner.adbannerId))) {
                            removeHandler(adbanner.adbannerId);
                            adbanner.deleteMap.split(',').map(function(adbannerId) {
                                removeHandler(adbannerId);
                            });
                            if (adbanner.image.url) {
                                adbanner.image.url = 'https://' + GLOBAL_SERVER_IP + ':9443' + adbanner.image.url;
                            }
                            var newAdBanner = {
                                image: adbanner.image,
                                interval: adbanner.interval,
                                startTime: Number(adbanner.startTime),
                                startDate: adbanner.startDate,
                                recursEvery: Number(adbanner.recursEvery),
                                daysOfWeek: adbanner.daysOfWeek,
                                nthWeek: Number(adbanner.nthWeek),
                                type: Number(adbanner.type)
                            };
                            if (newAdBanner.startTime === -1) {
                                adbannerHandler.init(Number(adbanner.adbannerId), newAdBanner);
                            } else {
                                /* set time on */
                                var currentDate = new Date();
                                var startDelay = Number(newAdBanner.startTime) - (currentDate.getHours() * 60 + currentDate.getMinutes());
                                if (startDelay < 0) {
                                    startDelay += 1440;
                                }

                                adbannerHandler._setTimeOut[adbanner.adbannerId] = setTimeout(function () {
                                    initHandler(adbanner.adbannerId, newAdBanner);
                                    adbannerHandler._setTimeInterval[adbanner.adbannerId] = setInterval(function () {
                                        initHandler(adbanner.adbannerId, newAdBanner)
                                    }, 1440 * 60 * 1000);
                                }, startDelay * 60 * 1000);
                            }
                        } else {
                            logConsole("isn't new event");
                        }
                    });
                }
            }

            function removeHandler(adbannerId) {
                if (adbannerHandler._setTimeOut[adbannerId] !== undefined) {
                    clearTimeout(adbannerHandler._setTimeOut[adbannerId]);
                    adbannerHandler._setTimeOut[adbannerId] = undefined;
                }
                if (adbannerHandler._setTimeInterval[adbannerId] !== undefined) {
                    clearInterval(adbannerHandler._setTimeInterval[adbannerId]);
                    adbannerHandler._setTimeInterval[adbannerId] = undefined;
                }
            }

            function initHandler(adbannerId, newAdBanner) {
                try {
                    var startDate = new Date(newAdBanner.startDate);
                    var checkDate = new Date();
                    checkDate.setHours(0);
                    checkDate.setMinutes(0);
                    checkDate.setSeconds(0);
                    checkDate.setMilliseconds(0);
                    switch(newAdBanner.type) {
                        case 1:
                            if(checkDate.getYear() === startDate.getYear() &&
                                checkDate.getMonth() === startDate.getMonth() &&
                                checkDate.getDate() === startDate.getDate() ) {
                                    adbannerHandler.init(Number(adbannerId), newAdBanner);
                            }
                            break;
                        case 2:
                            if(isAfterDate(startDate, checkDate)) {
                                if(getDateDiff(startDate, checkDate) % newAdBanner.recursEvery === 0) {
                                    adbannerHandler.init(Number(adbannerId), newAdBanner);
                                }
                            }
                            break;
                        case 3:
                            if(isAfterDate(startDate, checkDate)) {
                                if(getWeekDiff(startDate, checkDate) % newAdBanner.recursEvery === 0) {
                                    if(newAdBanner.daysOfWeek.substring(checkDate.getDay(), checkDate.getDay() + 1) === "O") {
                                        adbannerHandler.init(Number(adbannerId), newAdBanner);
                                    }
                                }
                            }
                            break;
                        case 4:
                            if(isAfterDate(startDate, checkDate)) {
                                if( ((checkDate.getYear() * 12 + checkDate.getMonth()) - (startDate.getYear() * 12 + startDate.getMonth())) % newAdBanner.recursEvery === 0) {
                                    var nthWeekStartDate = getNthWeekStartDate(checkDate, newAdBanner.nthWeek);
                                    var diff = getDateDiff(nthWeekStartDate, checkDate);
                                    if(diff >= 0 && diff < 7) {
                                        if(newAdBanner.daysOfWeek.substring(checkDate.getDay(), checkDate.getDay() + 1) === "O") {
                                            adbannerHandler.init(Number(adbannerId), newAdBanner);
                                        }
                                    }
                                }
                            }
                            break;
                    }
                } catch(e) {
                    logConsole(e.message);
                }
            }

            function isAfterDate(date1, date2) {
                if(date2.getYear() > date1.getYear() ||
                    (date2.getYear() === date1.getYear() && date2.getMonth() > date1.getMonth()) ||
                    (date2.getYear() === date1.getYear() && date2.getMonth() === date1.getMonth() && date2.getDate() >= date1.getDate()) ) {
                        return true;
                }
                return false;
            }

            function getDateDiff(date1, date2) {
                var timeDiff = Math.abs(date2.getTime() - date1.getTime());
                var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24));
                return diffDays;
            }

            function getWeekDiff(date1, date2) {
                var diffWeeks = Math.ceil(getDateDiff(getSunday(date1), getSunday(date2)) / 7);
                return diffWeeks;
            }

            function getSunday(d) {
                d = new Date(d);
                var day = d.getDay(),
                    diff = d.getDate() - day;
                return new Date(d.setDate(diff));
            }

            function getNthWeekStartDate(date1, nthWeek) {
                date1 = new Date(date1);
                date1.setDate(1);
                var day = date1.getDay();
                var diffDays = 0;
                var dayOfWeek = 0;
                if (day > dayOfWeek) {
                  diffDays = 7 - (day - dayOfWeek);
                } else {
                  diffDays = dayOfWeek - day;
                }
                diffDays += nthWeek * 7;
                date1.setTime(date1.getTime() + diffDays * (1000 * 3600 * 24));
                return date1;
            }
        },
        notifier: function (parsedJSON) {
            //logConsole('function notifier (parsedJSON) ' + JSON.stringify(parsedJSON));
            if (parsedJSON.type == 'notice') {
                var _parsedJSON = parsedJSON;
                function remoteOnTv() {
                    if (typeof (Storage) !== 'undefined' && parsedJSON.isRemoteOn) {
                        if ((localStorage.getItem('remoteOnNoticeId') !== null && localStorage.getItem('remoteOnNoticeId') < parsedJSON.remoteOnNoticeId)
                            || (localStorage.getItem('remoteOnNoticeId') === null)) {
                            // turn on the tv
                            hcap.power.getPowerMode({
                                onSuccess: function (s) {
                                    if (s.mode == hcap.power.PowerMode.WARM) {
                                        hcap.power.setPowerMode({
                                            mode: hcap.power.PowerMode.NORMAL,
                                            onSuccess: function () {
                                                logConsole("onSuccess");
                                                localStorage.setItem('remoteOnNoticeId', parsedJSON.remoteOnNoticeId);
                                            },
                                            onFailure: function (f) {
                                                logConsole("onFailure : errorMessage = " + f.errorMessage);
                                            }
                                        });
                                    }
                                },
                                onFailure: function (f) {
                                    logConsole('onFailure : errorMessage = ' + f.errorMessage);
                                }
                            });
                        }
                    }
                }

                function showNotifier(isLegacyCheckedIn) {
                    var newMsgCnt = 0;
                    var msgPmsType = getCookie("pmsType");

                    if( (getCookie("isPmsActive") === "true" && isLegacyCheckedIn) || isCheckedIn() || msgPmsType === "NONE" || msgPmsType === "" || isPreviewMode() ) {
                        remoteOnTv();
                        newMsgCnt = _parsedJSON.newNoticeCnt + _parsedJSON.newPMSNoticeCnt;
                    } else {
                        newMsgCnt = _parsedJSON.newNoticeCnt = _parsedJSON.newPMSNoticeCnt = 0;
                    }

					if(typeof messageIndicatorHandler !== 'undefined' && $.isEmptyObject(messageIndicatorHandler)===false) {
						messageIndicatorHandler.init(newMsgCnt);
					}
					if(typeof window.parent["notifierHandler"] !== 'undefined' && $.isEmptyObject(window.parent["notifierHandler"]) === false) {
						logConsole("[Notifier] PORTAL_ACTIVE : "+PORTAL_ACTIVE);
						if(typeof PORTAL_ACTIVE === "undefined") {
							logConsole("[Notifier] PORTAL_ACTIVE is UNDEFINED");
						} else {
							if(PORTAL_ACTIVE === false && _parsedJSON.notifierPopUpStyle.isActiveOnTV === "0") {
								logConsole("[Notifier] is not On TV and isActiveOnTv === 0");
							} else {
								logConsole("[Notifier] is On TV");
								if (_parsedJSON.notifierPopUpStyle.status === '1' && Number(newMsgCnt) > 0) {
									window.parent["notifierHandler"].init(_parsedJSON.notifierPopUpStyle, _parsedJSON.fontName);
									window.parent["notifierHandler"].show(_parsedJSON);
								}
							}
						}
					}
                }

				function updatePMSNoticeCnt(tvpmsData) {
					var isLegacyCheckedIn = false;
					var msgPmsType = getCookie("pmsType");
					try {
                        _parsedJSON.newPMSNoticeCnt = 0;
						$.each(tvpmsData.rooms, function(i, room){
							if (room.TVID === GLOBAL_SERIAL_NO) {
                                isLegacyCheckedIn = room.checkedIn ? true : false;

								if($.isArray(room.messages)){
									var newMessages = _.filter(room.messages, function(msg){
										var result = false;
										if(localStorage.getItem('pms_notifier_last_time') === null){
											result = true;
										}
										else {
											if(moment(msg.date).diff(localStorage.getItem('pms_notifier_last_time')) > 0 ) {
												result = true;
											}
										}
										return result;
									});
									_parsedJSON.newPMSNoticeCnt = newMessages.length;
								}
							}
                        });
                        showNotifier(isLegacyCheckedIn);
					} catch (e) {
						// is not a valid JSON string
					}
                }

                function updatePMSData () {
                    if(typeof parent.CACHE_PATH == 'undefined') {
                        loadJSON(updatePMSNoticeCnt, "http://127.0.0.1:8051/carousel_cache/1.2.2/tvpms.json", updatePMSNoticeCnt);
                    } else {
                        loadJSON(updatePMSNoticeCnt, parent.CACHE_PATH + "tvpms.json", updatePMSNoticeCnt);
                    }
                    if (_.isNull(intervalId)) {
                        intervalId = setInterval(updatePMSData, 60*1000);
                    }
                }
                if (typeof COM_TYPE === 'undefined' || COM_TYPE == 'IP') {
                    if (getCookie("pmsType") == 'LEGACY') {
                        updatePMSData();
                    } else {
                        showNotifier(false);
                    }
                }
            }
        },
        notice: function (parsedJSON) {
            var messages = [];
            if ($.isEmptyObject(parsedJSON) === false) { // Message Tab
                messages = parsedJSON.messages;
                if ((typeof (Storage) !== 'undefined') && messages.length > 0) {
                    var lastPcnMessage = _.find(messages, function(message) {
                        var messageId = _.toString(message.messageId);
                        return _.startsWith(messageId, "PCN_Message_");
                    });
                    var lastMessage = _.find(messages, function(message) {
                        var messageId = _.toString(message.messageId);
                        return !_.startsWith(messageId, "PCN_Message_");
                    });
                    localStorage.setItem('notifier_event_id', _.get(lastMessage, 'messageId', 0));
                    localStorage.setItem('pcn_notifier_event_id', _.get(lastPcnMessage, 'messageId', 0));
                }
            }

            function removeNoticeInLocal(checkInDateString) {
                var checkInDate = moment(checkInDateString).toDate();
                var checkIn = checkInDate.getTime() / 1000;

                var notice_read_string = localStorage.getItem("notice_read_list");
                var noticeReadList = [];
                if(notice_read_string !== null) {
                    try {
                        noticeReadList = JSON.parse(notice_read_string);
                    } catch(e) {}
                }
                noticeReadList = _.filter(noticeReadList, function(message){ return message.dt >= checkIn; });
                notice_read_string = JSON.stringify(noticeReadList);
                localStorage.setItem("notice_read_list", notice_read_string);
            }

            function noticeCallback(tvpmsData){  //TVPMS Data
                var isLegacyCheckedIn = false;
                var msgPmsType = getCookie("pmsType");
                try {
                    $.each(tvpmsData.rooms, function(i, room){
                        if (room.TVID === GLOBAL_SERIAL_NO) {
                            // remove notice read-state(read/unread) before checkInDate
                            if(room.checkInDate !== undefined) {
                                removeNoticeInLocal(room.checkInDate);
                            }
                            isLegacyCheckedIn = room.checkedIn ? true : false;
                            var pmsMessages = room.messages;

                            if($.isArray(pmsMessages)){
                                if(typeof(Storage) !== "undefined" && pmsMessages.length > 0) {
                                    localStorage.setItem('pms_notifier_last_time', _.first(_.sortBy(pmsMessages, function(msg){return -moment(msg.date)})).date);

                                    messages = _.sortBy (_.union(messages, _.map(pmsMessages, function(msg){
                                        return {"title" : msg.title, "message" : msg.text, "createdTime" : moment(msg.date).unix()};
                                    })), function(msg){
                                        return -moment(Number(msg.createdTime) * 1000);
                                    });
                                }
                            }
                        }
                    });
                } catch (e) {
                }

                if( (getCookie("isPmsActive") === "true" && isLegacyCheckedIn) || isCheckedIn() ||
                    msgPmsType === "NONE" || msgPmsType === "" || isPreviewMode()) {
                    if(typeof messageHandler !== 'undefined' && $.isEmptyObject(messageHandler)===false) {
                        messageHandler.init(messages);
                    }
                }
            }
            if(typeof parent.CACHE_PATH == 'undefined') {
            	loadJSON(noticeCallback, "http://127.0.0.1:8051/carousel_cache/1.2.2/tvpms.json", noticeCallback);
            } else {
            	loadJSON(noticeCallback, parent.CACHE_PATH + "tvpms.json", noticeCallback);
            }
        }
    };

    window.requestHandler.unsubscribeFromPage();
    var fromPage = true;
    var isButtonHandler = false;
    $.each(Object.keys(window), function(i, memberName){
        if(memberName.substr(0, "buttonHandler".length) === "buttonHandler") {
            isButtonHandler = true;
        }
    });
    if ((typeof oneClickServiceHandler !== 'undefined' && $.isPlainObject(window.oneClickServiceHandler)) || isButtonHandler) {
        events.push('one_click_service');
        window.requestHandler.subscribe('one_click_service', methods.one_click_service, fromPage);
    }
    if (typeof adbannerHandler !== 'undefined' && $.isPlainObject(window.adbannerHandler)) {
        window.requestHandler.subscribe('ad_banner', methods.ad_banner, fromPage);
        events.push('ad_banner');
    }
    if (typeof messageHandler !== 'undefined' && $.isPlainObject(window.messageHandler)) {
        window.requestHandler.subscribe('notice', methods.notice, fromPage);
        events.push('notice');
    } else {
        window.requestHandler.subscribe('notifier', methods.notifier, fromPage);
        events.push("notifier");
    }
    if (_.isEmpty(events) === false && $.isPlainObject(window.requestHandler)) {
        if(typeof COM_TYPE !== "undefined" && COM_TYPE === 'IP') {
            window.requestHandler.getEvents(events);
        }
    }
});
try {
    hcapPromise.property.getProperty({
        key: 'serial_number'
    }).then(function(param){
        window.GLOBAL_SERIAL_NO = param.value;
    }).catch(function(param){
        logConsole(param);
    });
} catch (e) {
    logConsole("Fail to get serial_number in page_polling");
}
