/***************************** SPEECH RECOGNITION FUNCTIONS Start*****************************/
var mappingObj;
var intents_array = {"items":[]};

function initSpeech() {
    //initialize the mapping table HERE.
    $.each(intents_array.items, function(i, item) {
       //logConsole("@@@@@initialize intent list : " + JSON.stringify(item));
       var current_item = item;
       //logConsole("@@@intent : " + current_item.intent + ", page name : " + current_item.url);
    });

    setSpeecRecognition(true);

    /* get Model name for POC */
    hcap.property.getProperty({
        "key": "model_name",
        "onSuccess": function(s) {
           var modelName = s.value;
           //logConsole("onSucess : model name = " + modelName);
           if(modelName.substring(0, 8) == "STB-5500") {
              VOICE_FOR_STB5500 = true;
           }
           logConsole("{utilities} Voice commands are enabled: " + VOICE_FOR_STB5500);
        },
        "onFailure": function(f) {
           logConsole("onFailure : errorMessage = " + f.errorMessage);
        }
    });
}

function getPageFromIntent(intent) {
    var url = 'none';
    $.each(intents_array.items, function(i, item) {
        if(intent == item.intent) {
           url = item.url;
           return url;
        }
    });
    return url;	
}

function watchTVWithSpeech() {
    if (isEditorMode() || isPreviewMode()) {
        //logConsole("In Editor/Preview mode this is disabled");
        return;
    }

    if(isVODPlaying() || !PORTAL_ACTIVE) {
        //logConsole("@@@ Portal is not ACTIVE or playing the VOD!!!");
        return;
    }
    getIframeObject().processButtonUserAction("", "Watch TV");
}

function changePageWithSpeech(message) {

    var request_url = message.value;
    var url = window.location.href;
    if(url.indexOf("checkout") !== -1 && (message.value == "yes" || message.value == "no")){
       request_url = "main";
    }

    if(isVODPlaying()) {
       var fDoc = getIframeObject();
       //clear media and go to the info page which is set.
       if(fDoc && typeof fDoc.exitVOD === "function") {
          fDoc.exitVOD(function() {
             if(request_url !== ""){
                var destination_url = request_url.toLowerCase() + ".html";
                if(!isPreviewMode() &&typeof getIframeObject().SyncBackgroundSettingsToParent === 'function') {
                   var fDoc = getIframeObject();
                   fDoc.SyncBackgroundSettingsToParent(request_url);
                }

                setTimeout(function() {
                   SetPortalStatus(SHOW_PORTAL);

                   setTimeout(function(){
                     document.getElementById('iframe_id').setAttribute('src', destination_url);
                     document.getElementById('iframe_id').addClass('hidden');
                   },500);
                },250);
             }
          }, "none");
       }
    } else {
       if(request_url !== ""){
           var destination_url = request_url.toLowerCase() + ".html";
           if(!isPreviewMode() &&typeof getIframeObject().SyncBackgroundSettingsToParent === 'function') {
              var fDoc = getIframeObject();
              fDoc.SyncBackgroundSettingsToParent(request_url);
           }

           setTimeout(function() {
              if (isPreviewMode() && destination_url.indexOf("src") == -1) {
                  destination_url = '/preview/src/' + destination_url;
                  document.getElementById('frame').setAttribute('src', destination_url);
              } else {
                    active_smartapp_id = localStorage.getItem("active_smartapp_id");
                    if (typeof active_smartapp_id === 'string' && active_smartapp_id != '') {
                        hcap.preloadedApplication.destroyPreloadedApplication({
                            "id" : active_smartapp_id,
                            "onSuccess" : function() {
                                localStorage.removeItem("active_smartapp_id");
                                //localStorage.setItem("changed_from_voice", true);
                                console.log("onSuccess");
                            },
                            "onFailure" : function(f) {
                                console.log("onFailure : errorMessage = " + f.errorMessage);
                            }
                        });
                    }

                    setTimeout(function(){
                        if(PORTAL_ACTIVE){
                            fDoc.goto(destination_url.replace(".html",""));
                        }else {
                            setTimeout(function(){
                                fDoc.window.location = "portal.html?page="+destination_url.replace(".html","");
                            }, 250);
                        
                            setTimeout(function(){
                                SetPortalStatus(SHOW_PORTAL);
                            },50);
                        }
                    
                    },500);
              }
           },250);
       }
    }
}

function channelChangeAfterHidePortal(command, ch_number) {
    var logMsg;
    var current_channel = getCookie('current_channel');	
    var ch;

    if(command.value == "up") {
       ch = channelUp(current_channel);
       logMsg = 'CH_UP - HCAP_key_handler.js';
    } else if(command.value == "down") {
       ch = channelDown(current_channel);
       logMsg = 'CH_DOWN - HCAP_key_handler.js';
    } else {
       ch = getPhysicalChannelInfo(ch_number);
       logMsg = 'GO TO CHANNEL - HCAP_key_handler.js';
       if(typeof ch.type == 'undefined' || ch.type == "SMART_APP" || ch.type == "URL") {
          logConsole("@@@Go to channel #" + ch_number + "is not a channel");
          return;
       }
    }

    var org_current_channel = parseInt(current_channel);
    var tmp_current_channel = parseInt(ch.logicalChannelNumber);

    while(ch.type == "SMART_APP" || ch.type == "URL") {
       if(command.value == "up") {
          ch = channelUp(tmp_current_channel);
       } else {
          ch = channelDown(tmp_current_channel);
       }

       if(org_current_channel == parseInt(ch.logicalChannelNumber)) {
          break;
       }
       tmp_current_channel = parseInt(ch.logicalChannelNumber);
    }

    if(ch.type != "SMART_APP" && ch.type != "URL") {
        setCookie("speech_channel", ch.logicalChannelNumber, COOKIE_EXPIRE_DAYS);
        watchTVWithSpeech();
    }
}

function channelChangeFromSpeech(command, ch_number) {
    var logMsg;
    if (checkPortalStatus()) {
        var current_channel = getCookie('current_channel');	
        var ch;
        if(command.value == "up") {
            ch = channelUp(current_channel);
            logMsg = 'CH_UP - HCAP_key_handler.js';
        } else if(command.value == "down") {
            ch = channelDown(current_channel);
            logMsg = 'CH_DOWN - HCAP_key_handler.js';
        } else {
            ch = getPhysicalChannelInfo(ch_number);
            logMsg = 'GO TO CHANNEL - HCAP_key_handler.js';
            if(typeof ch.type == 'undefined' || ch.type == "SMART_APP" || ch.type == "URL") {
                logConsole("@@@Go to channel #" + ch_number + "is not a channel");
                return;
            }
        }
        var org_current_channel = parseInt(current_channel);
        var tmp_current_channel = parseInt(ch.logicalChannelNumber);

        while(ch.type == "SMART_APP" || ch.type == "URL") {
            if(command.value == "up") {
                ch = channelUp(tmp_current_channel);
            } else {
                ch = channelDown(tmp_current_channel);
            }

            if(org_current_channel == parseInt(ch.logicalChannelNumber)) {
                break;
            }
            tmp_current_channel = parseInt(ch.logicalChannelNumber);
        }

        if(ch.type != "SMART_APP" && ch.type != "URL") {
            changeChannel(ch, null, 0, logMsg, function() {
                setTimeout(function() {
                    var current_channel = ch.logicalChannelNumber;
                    setCookie("current_channel", current_channel, COOKIE_EXPIRE_DAYS);
                    var url = "channelbanner.html?mode=tv&chNum=" + current_channel;
                    document.getElementById('iframe_id').setAttribute('src', url);
                }, 1500);
            });
        }
    }
}

function checkPortalStatus() {
    // check the live TV mode
    if(!PORTAL_ACTIVE || ($("#pip").length && !$('.rotana_channel_list').length)) {
    	if (isVODPlaying()) {
           logConsole("VOD Playing - CH UP/DOWN disabled");
           return false;
    	}
        return true;
    }
    return false;
}

function setSpeecRecognition(voiceRecognition) {
    //logConsole("{utilities} Setting speech recognition = " + voiceRecognition);
    hcap.speech.getSpeechRecognition({
       "onSuccess" : function (param) {
           //logConsole("@@@@@ SPEECH - onSuccess : get speech recognition = " + param.enable);

           if(param.enable != voiceRecognition) {
              // Enable the embeded NLP
              hcap.speech.setSpeechRecognition({
                 "enable" : voiceRecognition,
                 "onSuccess" : function() {
                     logConsole("{utilities} Enabled speech recognition!");
                 }, 
                 "onFailure" : function(f) {
                     logConsole("{utilities} Failed to enable speech recognition: " + f.errorMessage);
                 }
              });           
           }
       }, 
       "onFailure" : function(f) {
           logConsole("{utilities} Failed to get speech recognition: " + f.errorMessage);
       }
    });
}
/***************************** SPEECH RECOGNITION FUNCTIONS END*****************************/
